#include <ESP8266WiFi.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"

#define WIFI_SSID "..........SSID..........."//Your wifi name
#define WIFI_PASS "...........PASSWORD........."//your wifi password

#define MQTT_SERV "io.adafruit.com"
#define MQTT_PORT 1883
#define MQTT_NAME "..........Adafruit ID.........." //Your adafruit name
#define MQTT_PASS "..............AIO KEY............" //Your adafruit AIO key

int r=255, g=255, b=255;

WiFiClient client;
Adafruit_MQTT_Client mqtt(&client, MQTT_SERV, MQTT_PORT, MQTT_NAME, MQTT_PASS);

Adafruit_MQTT_Subscribe BAYMAX = Adafruit_MQTT_Subscribe(&mqtt, MQTT_NAME "/f/BAYMAX");
void setup()
{
  Serial.begin(9600);

  //Connect to WiFi
  Serial.print("\n\nConnecting Wifi>");
  WiFi.begin(WIFI_SSID, WIFI_PASS);

  while (WiFi.status() != WL_CONNECTED)
  {
    Serial.print(">");
    delay(50);
  }

  Serial.println("OK!");

  //Subscribe to the BAYMAX topic
  mqtt.subscribe(&BAYMAX);

  pinMode(D5, OUTPUT); //r
  pinMode(D6, OUTPUT); //g
  pinMode(D7, OUTPUT); //b

}

void loop()
{
  //SET led color
 analogWrite(D5,r);
 analogWrite(D6,g);
 analogWrite(D7,b);

  //Connect/Reconnect to MQTT
  MQTT_connect();

  //Read from our subscription queue until we run out, or
  //wait up to 5 seconds for subscription to update
  Adafruit_MQTT_Subscribe * subscription;
  while ((subscription = mqtt.readSubscription(5000)))
  {
    //If we're in here, a subscription updated...
    if (subscription == &BAYMAX)
    {
      //Print the new value to the serial monitor
      Serial.print("STATE: ");
      Serial.println((char*) BAYMAX.lastread);

      //If the new value is  "1", turn the light red.
      if (!strcmp((char*) BAYMAX.lastread, "1"))
      {
        r=255;
        g=0;
        b=0;
      }
    //If the new value is  "2", turn the light blue.
      else if (!strcmp((char*) BAYMAX.lastread, "2"))
      {
        r=0;
        g=0;
        b=255;
      }

      //If the new value is  "3", turn the light green.
      else if (!strcmp((char*) BAYMAX.lastread, "3"))
      {
        r=0;
        g=255;
        b=0;
      }
      
      //if none, turn the light back to white
      else
      {
        r=255;
        g=255;
        b=255;     
      }
     
    }
  }

}


void MQTT_connect()
{

  //  // Stop if already connected
  if (mqtt.connected() && mqtt.ping())
  {
    //    mqtt.disconnect();
    return;
  }

  int8_t ret;

  mqtt.disconnect();

  Serial.print("Connecting to MQTT... ");
  uint8_t retries = 3;
  while ((ret = mqtt.connect()) != 0) // connect will return 0 for connected
  {
    Serial.println(mqtt.connectErrorString(ret));
    Serial.println("Retrying MQTT connection in 5 seconds...");
    mqtt.disconnect();
    delay(5000);  // wait 5 seconds
    retries--;
    if (retries == 0)
    {
      ESP.reset();
    }
  }
  Serial.println("MQTT Connected!");
}
